/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class SlotValue extends org.apache.thrift.TUnion<SlotValue, SlotValue._Fields> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("SlotValue");
  private static final org.apache.thrift.protocol.TField V_BOOLEAN_FIELD_DESC = new org.apache.thrift.protocol.TField("vBoolean", org.apache.thrift.protocol.TType.BOOL, (short)1);
  private static final org.apache.thrift.protocol.TField V_BYTE_FIELD_DESC = new org.apache.thrift.protocol.TField("vByte", org.apache.thrift.protocol.TType.BYTE, (short)2);
  private static final org.apache.thrift.protocol.TField V_SHORT_FIELD_DESC = new org.apache.thrift.protocol.TField("vShort", org.apache.thrift.protocol.TType.I16, (short)3);
  private static final org.apache.thrift.protocol.TField V_INTEGER_FIELD_DESC = new org.apache.thrift.protocol.TField("vInteger", org.apache.thrift.protocol.TType.I32, (short)4);
  private static final org.apache.thrift.protocol.TField V_LONG_FIELD_DESC = new org.apache.thrift.protocol.TField("vLong", org.apache.thrift.protocol.TType.I64, (short)5);
  private static final org.apache.thrift.protocol.TField V_DOUBLE_FIELD_DESC = new org.apache.thrift.protocol.TField("vDouble", org.apache.thrift.protocol.TType.DOUBLE, (short)6);
  private static final org.apache.thrift.protocol.TField V_STRING_FIELD_DESC = new org.apache.thrift.protocol.TField("vString", org.apache.thrift.protocol.TType.STRING, (short)7);
  private static final org.apache.thrift.protocol.TField V_BOOLEANS_FIELD_DESC = new org.apache.thrift.protocol.TField("vBooleans", org.apache.thrift.protocol.TType.LIST, (short)8);
  private static final org.apache.thrift.protocol.TField V_BYTES_FIELD_DESC = new org.apache.thrift.protocol.TField("vBytes", org.apache.thrift.protocol.TType.STRING, (short)9);
  private static final org.apache.thrift.protocol.TField V_SHORTS_FIELD_DESC = new org.apache.thrift.protocol.TField("vShorts", org.apache.thrift.protocol.TType.LIST, (short)10);
  private static final org.apache.thrift.protocol.TField V_INTEGERS_FIELD_DESC = new org.apache.thrift.protocol.TField("vIntegers", org.apache.thrift.protocol.TType.LIST, (short)11);
  private static final org.apache.thrift.protocol.TField V_LONGS_FIELD_DESC = new org.apache.thrift.protocol.TField("vLongs", org.apache.thrift.protocol.TType.LIST, (short)12);
  private static final org.apache.thrift.protocol.TField V_DOUBLES_FIELD_DESC = new org.apache.thrift.protocol.TField("vDoubles", org.apache.thrift.protocol.TType.LIST, (short)13);
  private static final org.apache.thrift.protocol.TField V_STRINGS_FIELD_DESC = new org.apache.thrift.protocol.TField("vStrings", org.apache.thrift.protocol.TType.LIST, (short)14);
  private static final org.apache.thrift.protocol.TField V_LISTS_FIELD_DESC = new org.apache.thrift.protocol.TField("vLists", org.apache.thrift.protocol.TType.LIST, (short)15);

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    V_BOOLEAN((short)1, "vBoolean"),
    V_BYTE((short)2, "vByte"),
    V_SHORT((short)3, "vShort"),
    V_INTEGER((short)4, "vInteger"),
    V_LONG((short)5, "vLong"),
    V_DOUBLE((short)6, "vDouble"),
    V_STRING((short)7, "vString"),
    V_BOOLEANS((short)8, "vBooleans"),
    V_BYTES((short)9, "vBytes"),
    V_SHORTS((short)10, "vShorts"),
    V_INTEGERS((short)11, "vIntegers"),
    V_LONGS((short)12, "vLongs"),
    V_DOUBLES((short)13, "vDoubles"),
    V_STRINGS((short)14, "vStrings"),
    V_LISTS((short)15, "vLists");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // V_BOOLEAN
          return V_BOOLEAN;
        case 2: // V_BYTE
          return V_BYTE;
        case 3: // V_SHORT
          return V_SHORT;
        case 4: // V_INTEGER
          return V_INTEGER;
        case 5: // V_LONG
          return V_LONG;
        case 6: // V_DOUBLE
          return V_DOUBLE;
        case 7: // V_STRING
          return V_STRING;
        case 8: // V_BOOLEANS
          return V_BOOLEANS;
        case 9: // V_BYTES
          return V_BYTES;
        case 10: // V_SHORTS
          return V_SHORTS;
        case 11: // V_INTEGERS
          return V_INTEGERS;
        case 12: // V_LONGS
          return V_LONGS;
        case 13: // V_DOUBLES
          return V_DOUBLES;
        case 14: // V_STRINGS
          return V_STRINGS;
        case 15: // V_LISTS
          return V_LISTS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.V_BOOLEAN, new org.apache.thrift.meta_data.FieldMetaData("vBoolean", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
    tmpMap.put(_Fields.V_BYTE, new org.apache.thrift.meta_data.FieldMetaData("vByte", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BYTE)));
    tmpMap.put(_Fields.V_SHORT, new org.apache.thrift.meta_data.FieldMetaData("vShort", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I16)));
    tmpMap.put(_Fields.V_INTEGER, new org.apache.thrift.meta_data.FieldMetaData("vInteger", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32)));
    tmpMap.put(_Fields.V_LONG, new org.apache.thrift.meta_data.FieldMetaData("vLong", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.V_DOUBLE, new org.apache.thrift.meta_data.FieldMetaData("vDouble", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.V_STRING, new org.apache.thrift.meta_data.FieldMetaData("vString", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.V_BOOLEANS, new org.apache.thrift.meta_data.FieldMetaData("vBooleans", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL))));
    tmpMap.put(_Fields.V_BYTES, new org.apache.thrift.meta_data.FieldMetaData("vBytes", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING        , true)));
    tmpMap.put(_Fields.V_SHORTS, new org.apache.thrift.meta_data.FieldMetaData("vShorts", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I16))));
    tmpMap.put(_Fields.V_INTEGERS, new org.apache.thrift.meta_data.FieldMetaData("vIntegers", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32))));
    tmpMap.put(_Fields.V_LONGS, new org.apache.thrift.meta_data.FieldMetaData("vLongs", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64))));
    tmpMap.put(_Fields.V_DOUBLES, new org.apache.thrift.meta_data.FieldMetaData("vDoubles", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE))));
    tmpMap.put(_Fields.V_STRINGS, new org.apache.thrift.meta_data.FieldMetaData("vStrings", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING))));
    tmpMap.put(_Fields.V_LISTS, new org.apache.thrift.meta_data.FieldMetaData("vLists", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRUCT            , "SlotValue"))));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(SlotValue.class, metaDataMap);
  }

  public SlotValue() {
    super();
  }

  public SlotValue(_Fields setField, java.lang.Object value) {
    super(setField, value);
  }

  public SlotValue(SlotValue other) {
    super(other);
  }
  public SlotValue deepCopy() {
    return new SlotValue(this);
  }

  public static SlotValue vBoolean(boolean value) {
    SlotValue x = new SlotValue();
    x.setVBoolean(value);
    return x;
  }

  public static SlotValue vByte(byte value) {
    SlotValue x = new SlotValue();
    x.setVByte(value);
    return x;
  }

  public static SlotValue vShort(short value) {
    SlotValue x = new SlotValue();
    x.setVShort(value);
    return x;
  }

  public static SlotValue vInteger(int value) {
    SlotValue x = new SlotValue();
    x.setVInteger(value);
    return x;
  }

  public static SlotValue vLong(long value) {
    SlotValue x = new SlotValue();
    x.setVLong(value);
    return x;
  }

  public static SlotValue vDouble(double value) {
    SlotValue x = new SlotValue();
    x.setVDouble(value);
    return x;
  }

  public static SlotValue vString(java.lang.String value) {
    SlotValue x = new SlotValue();
    x.setVString(value);
    return x;
  }

  public static SlotValue vBooleans(java.util.List<java.lang.Boolean> value) {
    SlotValue x = new SlotValue();
    x.setVBooleans(value);
    return x;
  }

  public static SlotValue vBytes(java.nio.ByteBuffer value) {
    SlotValue x = new SlotValue();
    x.setVBytes(value);
    return x;
  }

  public static SlotValue vBytes(byte[] value) {
    SlotValue x = new SlotValue();
    x.setVBytes  (java.nio.ByteBuffer.wrap(value.clone()));
    return x;
  }

  public static SlotValue vShorts(java.util.List<java.lang.Short> value) {
    SlotValue x = new SlotValue();
    x.setVShorts(value);
    return x;
  }

  public static SlotValue vIntegers(java.util.List<java.lang.Integer> value) {
    SlotValue x = new SlotValue();
    x.setVIntegers(value);
    return x;
  }

  public static SlotValue vLongs(java.util.List<java.lang.Long> value) {
    SlotValue x = new SlotValue();
    x.setVLongs(value);
    return x;
  }

  public static SlotValue vDoubles(java.util.List<java.lang.Double> value) {
    SlotValue x = new SlotValue();
    x.setVDoubles(value);
    return x;
  }

  public static SlotValue vStrings(java.util.List<java.lang.String> value) {
    SlotValue x = new SlotValue();
    x.setVStrings(value);
    return x;
  }

  public static SlotValue vLists(java.util.List<SlotValue> value) {
    SlotValue x = new SlotValue();
    x.setVLists(value);
    return x;
  }


  @Override
  protected void checkType(_Fields setField, java.lang.Object value) throws java.lang.ClassCastException {
    switch (setField) {
      case V_BOOLEAN:
        if (value instanceof java.lang.Boolean) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Boolean for field 'vBoolean', but got " + value.getClass().getSimpleName());
      case V_BYTE:
        if (value instanceof java.lang.Byte) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Byte for field 'vByte', but got " + value.getClass().getSimpleName());
      case V_SHORT:
        if (value instanceof java.lang.Short) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Short for field 'vShort', but got " + value.getClass().getSimpleName());
      case V_INTEGER:
        if (value instanceof java.lang.Integer) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Integer for field 'vInteger', but got " + value.getClass().getSimpleName());
      case V_LONG:
        if (value instanceof java.lang.Long) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Long for field 'vLong', but got " + value.getClass().getSimpleName());
      case V_DOUBLE:
        if (value instanceof java.lang.Double) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.Double for field 'vDouble', but got " + value.getClass().getSimpleName());
      case V_STRING:
        if (value instanceof java.lang.String) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.lang.String for field 'vString', but got " + value.getClass().getSimpleName());
      case V_BOOLEANS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.Boolean> for field 'vBooleans', but got " + value.getClass().getSimpleName());
      case V_BYTES:
        if (value instanceof java.nio.ByteBuffer) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.nio.ByteBuffer for field 'vBytes', but got " + value.getClass().getSimpleName());
      case V_SHORTS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.Short> for field 'vShorts', but got " + value.getClass().getSimpleName());
      case V_INTEGERS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.Integer> for field 'vIntegers', but got " + value.getClass().getSimpleName());
      case V_LONGS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.Long> for field 'vLongs', but got " + value.getClass().getSimpleName());
      case V_DOUBLES:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.Double> for field 'vDoubles', but got " + value.getClass().getSimpleName());
      case V_STRINGS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<java.lang.String> for field 'vStrings', but got " + value.getClass().getSimpleName());
      case V_LISTS:
        if (value instanceof java.util.List) {
          break;
        }
        throw new java.lang.ClassCastException("Was expecting value of type java.util.List<SlotValue> for field 'vLists', but got " + value.getClass().getSimpleName());
      default:
        throw new java.lang.IllegalArgumentException("Unknown field id " + setField);
    }
  }

  @Override
  protected java.lang.Object standardSchemeReadValue(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TField field) throws org.apache.thrift.TException {
    _Fields setField = _Fields.findByThriftId(field.id);
    if (setField != null) {
      switch (setField) {
        case V_BOOLEAN:
          if (field.type == V_BOOLEAN_FIELD_DESC.type) {
            java.lang.Boolean vBoolean;
            vBoolean = iprot.readBool();
            return vBoolean;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_BYTE:
          if (field.type == V_BYTE_FIELD_DESC.type) {
            java.lang.Byte vByte;
            vByte = iprot.readByte();
            return vByte;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_SHORT:
          if (field.type == V_SHORT_FIELD_DESC.type) {
            java.lang.Short vShort;
            vShort = iprot.readI16();
            return vShort;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_INTEGER:
          if (field.type == V_INTEGER_FIELD_DESC.type) {
            java.lang.Integer vInteger;
            vInteger = iprot.readI32();
            return vInteger;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_LONG:
          if (field.type == V_LONG_FIELD_DESC.type) {
            java.lang.Long vLong;
            vLong = iprot.readI64();
            return vLong;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_DOUBLE:
          if (field.type == V_DOUBLE_FIELD_DESC.type) {
            java.lang.Double vDouble;
            vDouble = iprot.readDouble();
            return vDouble;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_STRING:
          if (field.type == V_STRING_FIELD_DESC.type) {
            java.lang.String vString;
            vString = iprot.readString();
            return vString;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_BOOLEANS:
          if (field.type == V_BOOLEANS_FIELD_DESC.type) {
            java.util.List<java.lang.Boolean> vBooleans;
            {
              org.apache.thrift.protocol.TList _list16 = iprot.readListBegin();
              vBooleans = new java.util.ArrayList<java.lang.Boolean>(_list16.size);
              boolean _elem17;
              for (int _i18 = 0; _i18 < _list16.size; ++_i18)
              {
                _elem17 = iprot.readBool();
                vBooleans.add(_elem17);
              }
              iprot.readListEnd();
            }
            return vBooleans;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_BYTES:
          if (field.type == V_BYTES_FIELD_DESC.type) {
            java.nio.ByteBuffer vBytes;
            vBytes = iprot.readBinary();
            return vBytes;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_SHORTS:
          if (field.type == V_SHORTS_FIELD_DESC.type) {
            java.util.List<java.lang.Short> vShorts;
            {
              org.apache.thrift.protocol.TList _list19 = iprot.readListBegin();
              vShorts = new java.util.ArrayList<java.lang.Short>(_list19.size);
              short _elem20;
              for (int _i21 = 0; _i21 < _list19.size; ++_i21)
              {
                _elem20 = iprot.readI16();
                vShorts.add(_elem20);
              }
              iprot.readListEnd();
            }
            return vShorts;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_INTEGERS:
          if (field.type == V_INTEGERS_FIELD_DESC.type) {
            java.util.List<java.lang.Integer> vIntegers;
            {
              org.apache.thrift.protocol.TList _list22 = iprot.readListBegin();
              vIntegers = new java.util.ArrayList<java.lang.Integer>(_list22.size);
              int _elem23;
              for (int _i24 = 0; _i24 < _list22.size; ++_i24)
              {
                _elem23 = iprot.readI32();
                vIntegers.add(_elem23);
              }
              iprot.readListEnd();
            }
            return vIntegers;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_LONGS:
          if (field.type == V_LONGS_FIELD_DESC.type) {
            java.util.List<java.lang.Long> vLongs;
            {
              org.apache.thrift.protocol.TList _list25 = iprot.readListBegin();
              vLongs = new java.util.ArrayList<java.lang.Long>(_list25.size);
              long _elem26;
              for (int _i27 = 0; _i27 < _list25.size; ++_i27)
              {
                _elem26 = iprot.readI64();
                vLongs.add(_elem26);
              }
              iprot.readListEnd();
            }
            return vLongs;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_DOUBLES:
          if (field.type == V_DOUBLES_FIELD_DESC.type) {
            java.util.List<java.lang.Double> vDoubles;
            {
              org.apache.thrift.protocol.TList _list28 = iprot.readListBegin();
              vDoubles = new java.util.ArrayList<java.lang.Double>(_list28.size);
              double _elem29;
              for (int _i30 = 0; _i30 < _list28.size; ++_i30)
              {
                _elem29 = iprot.readDouble();
                vDoubles.add(_elem29);
              }
              iprot.readListEnd();
            }
            return vDoubles;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_STRINGS:
          if (field.type == V_STRINGS_FIELD_DESC.type) {
            java.util.List<java.lang.String> vStrings;
            {
              org.apache.thrift.protocol.TList _list31 = iprot.readListBegin();
              vStrings = new java.util.ArrayList<java.lang.String>(_list31.size);
              @org.apache.thrift.annotation.Nullable java.lang.String _elem32;
              for (int _i33 = 0; _i33 < _list31.size; ++_i33)
              {
                _elem32 = iprot.readString();
                vStrings.add(_elem32);
              }
              iprot.readListEnd();
            }
            return vStrings;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        case V_LISTS:
          if (field.type == V_LISTS_FIELD_DESC.type) {
            java.util.List<SlotValue> vLists;
            {
              org.apache.thrift.protocol.TList _list34 = iprot.readListBegin();
              vLists = new java.util.ArrayList<SlotValue>(_list34.size);
              @org.apache.thrift.annotation.Nullable SlotValue _elem35;
              for (int _i36 = 0; _i36 < _list34.size; ++_i36)
              {
                _elem35 = new SlotValue();
                _elem35.read(iprot);
                vLists.add(_elem35);
              }
              iprot.readListEnd();
            }
            return vLists;
          } else {
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
            return null;
          }
        default:
          throw new java.lang.IllegalStateException("setField wasn't null, but didn't match any of the case statements!");
      }
    } else {
      org.apache.thrift.protocol.TProtocolUtil.skip(iprot, field.type);
      return null;
    }
  }

  @Override
  protected void standardSchemeWriteValue(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    switch (setField_) {
      case V_BOOLEAN:
        java.lang.Boolean vBoolean = (java.lang.Boolean)value_;
        oprot.writeBool(vBoolean);
        return;
      case V_BYTE:
        java.lang.Byte vByte = (java.lang.Byte)value_;
        oprot.writeByte(vByte);
        return;
      case V_SHORT:
        java.lang.Short vShort = (java.lang.Short)value_;
        oprot.writeI16(vShort);
        return;
      case V_INTEGER:
        java.lang.Integer vInteger = (java.lang.Integer)value_;
        oprot.writeI32(vInteger);
        return;
      case V_LONG:
        java.lang.Long vLong = (java.lang.Long)value_;
        oprot.writeI64(vLong);
        return;
      case V_DOUBLE:
        java.lang.Double vDouble = (java.lang.Double)value_;
        oprot.writeDouble(vDouble);
        return;
      case V_STRING:
        java.lang.String vString = (java.lang.String)value_;
        oprot.writeString(vString);
        return;
      case V_BOOLEANS:
        java.util.List<java.lang.Boolean> vBooleans = (java.util.List<java.lang.Boolean>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.BOOL, vBooleans.size()));
          for (boolean _iter37 : vBooleans)
          {
            oprot.writeBool(_iter37);
          }
          oprot.writeListEnd();
        }
        return;
      case V_BYTES:
        java.nio.ByteBuffer vBytes = (java.nio.ByteBuffer)value_;
        oprot.writeBinary(vBytes);
        return;
      case V_SHORTS:
        java.util.List<java.lang.Short> vShorts = (java.util.List<java.lang.Short>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I16, vShorts.size()));
          for (short _iter38 : vShorts)
          {
            oprot.writeI16(_iter38);
          }
          oprot.writeListEnd();
        }
        return;
      case V_INTEGERS:
        java.util.List<java.lang.Integer> vIntegers = (java.util.List<java.lang.Integer>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I32, vIntegers.size()));
          for (int _iter39 : vIntegers)
          {
            oprot.writeI32(_iter39);
          }
          oprot.writeListEnd();
        }
        return;
      case V_LONGS:
        java.util.List<java.lang.Long> vLongs = (java.util.List<java.lang.Long>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, vLongs.size()));
          for (long _iter40 : vLongs)
          {
            oprot.writeI64(_iter40);
          }
          oprot.writeListEnd();
        }
        return;
      case V_DOUBLES:
        java.util.List<java.lang.Double> vDoubles = (java.util.List<java.lang.Double>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.DOUBLE, vDoubles.size()));
          for (double _iter41 : vDoubles)
          {
            oprot.writeDouble(_iter41);
          }
          oprot.writeListEnd();
        }
        return;
      case V_STRINGS:
        java.util.List<java.lang.String> vStrings = (java.util.List<java.lang.String>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, vStrings.size()));
          for (java.lang.String _iter42 : vStrings)
          {
            oprot.writeString(_iter42);
          }
          oprot.writeListEnd();
        }
        return;
      case V_LISTS:
        java.util.List<SlotValue> vLists = (java.util.List<SlotValue>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, vLists.size()));
          for (SlotValue _iter43 : vLists)
          {
            _iter43.write(oprot);
          }
          oprot.writeListEnd();
        }
        return;
      default:
        throw new java.lang.IllegalStateException("Cannot write union with unknown field " + setField_);
    }
  }

  @Override
  protected java.lang.Object tupleSchemeReadValue(org.apache.thrift.protocol.TProtocol iprot, short fieldID) throws org.apache.thrift.TException {
    _Fields setField = _Fields.findByThriftId(fieldID);
    if (setField != null) {
      switch (setField) {
        case V_BOOLEAN:
          java.lang.Boolean vBoolean;
          vBoolean = iprot.readBool();
          return vBoolean;
        case V_BYTE:
          java.lang.Byte vByte;
          vByte = iprot.readByte();
          return vByte;
        case V_SHORT:
          java.lang.Short vShort;
          vShort = iprot.readI16();
          return vShort;
        case V_INTEGER:
          java.lang.Integer vInteger;
          vInteger = iprot.readI32();
          return vInteger;
        case V_LONG:
          java.lang.Long vLong;
          vLong = iprot.readI64();
          return vLong;
        case V_DOUBLE:
          java.lang.Double vDouble;
          vDouble = iprot.readDouble();
          return vDouble;
        case V_STRING:
          java.lang.String vString;
          vString = iprot.readString();
          return vString;
        case V_BOOLEANS:
          java.util.List<java.lang.Boolean> vBooleans;
          {
            org.apache.thrift.protocol.TList _list44 = iprot.readListBegin();
            vBooleans = new java.util.ArrayList<java.lang.Boolean>(_list44.size);
            boolean _elem45;
            for (int _i46 = 0; _i46 < _list44.size; ++_i46)
            {
              _elem45 = iprot.readBool();
              vBooleans.add(_elem45);
            }
            iprot.readListEnd();
          }
          return vBooleans;
        case V_BYTES:
          java.nio.ByteBuffer vBytes;
          vBytes = iprot.readBinary();
          return vBytes;
        case V_SHORTS:
          java.util.List<java.lang.Short> vShorts;
          {
            org.apache.thrift.protocol.TList _list47 = iprot.readListBegin();
            vShorts = new java.util.ArrayList<java.lang.Short>(_list47.size);
            short _elem48;
            for (int _i49 = 0; _i49 < _list47.size; ++_i49)
            {
              _elem48 = iprot.readI16();
              vShorts.add(_elem48);
            }
            iprot.readListEnd();
          }
          return vShorts;
        case V_INTEGERS:
          java.util.List<java.lang.Integer> vIntegers;
          {
            org.apache.thrift.protocol.TList _list50 = iprot.readListBegin();
            vIntegers = new java.util.ArrayList<java.lang.Integer>(_list50.size);
            int _elem51;
            for (int _i52 = 0; _i52 < _list50.size; ++_i52)
            {
              _elem51 = iprot.readI32();
              vIntegers.add(_elem51);
            }
            iprot.readListEnd();
          }
          return vIntegers;
        case V_LONGS:
          java.util.List<java.lang.Long> vLongs;
          {
            org.apache.thrift.protocol.TList _list53 = iprot.readListBegin();
            vLongs = new java.util.ArrayList<java.lang.Long>(_list53.size);
            long _elem54;
            for (int _i55 = 0; _i55 < _list53.size; ++_i55)
            {
              _elem54 = iprot.readI64();
              vLongs.add(_elem54);
            }
            iprot.readListEnd();
          }
          return vLongs;
        case V_DOUBLES:
          java.util.List<java.lang.Double> vDoubles;
          {
            org.apache.thrift.protocol.TList _list56 = iprot.readListBegin();
            vDoubles = new java.util.ArrayList<java.lang.Double>(_list56.size);
            double _elem57;
            for (int _i58 = 0; _i58 < _list56.size; ++_i58)
            {
              _elem57 = iprot.readDouble();
              vDoubles.add(_elem57);
            }
            iprot.readListEnd();
          }
          return vDoubles;
        case V_STRINGS:
          java.util.List<java.lang.String> vStrings;
          {
            org.apache.thrift.protocol.TList _list59 = iprot.readListBegin();
            vStrings = new java.util.ArrayList<java.lang.String>(_list59.size);
            @org.apache.thrift.annotation.Nullable java.lang.String _elem60;
            for (int _i61 = 0; _i61 < _list59.size; ++_i61)
            {
              _elem60 = iprot.readString();
              vStrings.add(_elem60);
            }
            iprot.readListEnd();
          }
          return vStrings;
        case V_LISTS:
          java.util.List<SlotValue> vLists;
          {
            org.apache.thrift.protocol.TList _list62 = iprot.readListBegin();
            vLists = new java.util.ArrayList<SlotValue>(_list62.size);
            @org.apache.thrift.annotation.Nullable SlotValue _elem63;
            for (int _i64 = 0; _i64 < _list62.size; ++_i64)
            {
              _elem63 = new SlotValue();
              _elem63.read(iprot);
              vLists.add(_elem63);
            }
            iprot.readListEnd();
          }
          return vLists;
        default:
          throw new java.lang.IllegalStateException("setField wasn't null, but didn't match any of the case statements!");
      }
    } else {
      throw new org.apache.thrift.protocol.TProtocolException("Couldn't find a field with field id " + fieldID);
    }
  }

  @Override
  protected void tupleSchemeWriteValue(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    switch (setField_) {
      case V_BOOLEAN:
        java.lang.Boolean vBoolean = (java.lang.Boolean)value_;
        oprot.writeBool(vBoolean);
        return;
      case V_BYTE:
        java.lang.Byte vByte = (java.lang.Byte)value_;
        oprot.writeByte(vByte);
        return;
      case V_SHORT:
        java.lang.Short vShort = (java.lang.Short)value_;
        oprot.writeI16(vShort);
        return;
      case V_INTEGER:
        java.lang.Integer vInteger = (java.lang.Integer)value_;
        oprot.writeI32(vInteger);
        return;
      case V_LONG:
        java.lang.Long vLong = (java.lang.Long)value_;
        oprot.writeI64(vLong);
        return;
      case V_DOUBLE:
        java.lang.Double vDouble = (java.lang.Double)value_;
        oprot.writeDouble(vDouble);
        return;
      case V_STRING:
        java.lang.String vString = (java.lang.String)value_;
        oprot.writeString(vString);
        return;
      case V_BOOLEANS:
        java.util.List<java.lang.Boolean> vBooleans = (java.util.List<java.lang.Boolean>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.BOOL, vBooleans.size()));
          for (boolean _iter65 : vBooleans)
          {
            oprot.writeBool(_iter65);
          }
          oprot.writeListEnd();
        }
        return;
      case V_BYTES:
        java.nio.ByteBuffer vBytes = (java.nio.ByteBuffer)value_;
        oprot.writeBinary(vBytes);
        return;
      case V_SHORTS:
        java.util.List<java.lang.Short> vShorts = (java.util.List<java.lang.Short>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I16, vShorts.size()));
          for (short _iter66 : vShorts)
          {
            oprot.writeI16(_iter66);
          }
          oprot.writeListEnd();
        }
        return;
      case V_INTEGERS:
        java.util.List<java.lang.Integer> vIntegers = (java.util.List<java.lang.Integer>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I32, vIntegers.size()));
          for (int _iter67 : vIntegers)
          {
            oprot.writeI32(_iter67);
          }
          oprot.writeListEnd();
        }
        return;
      case V_LONGS:
        java.util.List<java.lang.Long> vLongs = (java.util.List<java.lang.Long>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, vLongs.size()));
          for (long _iter68 : vLongs)
          {
            oprot.writeI64(_iter68);
          }
          oprot.writeListEnd();
        }
        return;
      case V_DOUBLES:
        java.util.List<java.lang.Double> vDoubles = (java.util.List<java.lang.Double>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.DOUBLE, vDoubles.size()));
          for (double _iter69 : vDoubles)
          {
            oprot.writeDouble(_iter69);
          }
          oprot.writeListEnd();
        }
        return;
      case V_STRINGS:
        java.util.List<java.lang.String> vStrings = (java.util.List<java.lang.String>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, vStrings.size()));
          for (java.lang.String _iter70 : vStrings)
          {
            oprot.writeString(_iter70);
          }
          oprot.writeListEnd();
        }
        return;
      case V_LISTS:
        java.util.List<SlotValue> vLists = (java.util.List<SlotValue>)value_;
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, vLists.size()));
          for (SlotValue _iter71 : vLists)
          {
            _iter71.write(oprot);
          }
          oprot.writeListEnd();
        }
        return;
      default:
        throw new java.lang.IllegalStateException("Cannot write union with unknown field " + setField_);
    }
  }

  @Override
  protected org.apache.thrift.protocol.TField getFieldDesc(_Fields setField) {
    switch (setField) {
      case V_BOOLEAN:
        return V_BOOLEAN_FIELD_DESC;
      case V_BYTE:
        return V_BYTE_FIELD_DESC;
      case V_SHORT:
        return V_SHORT_FIELD_DESC;
      case V_INTEGER:
        return V_INTEGER_FIELD_DESC;
      case V_LONG:
        return V_LONG_FIELD_DESC;
      case V_DOUBLE:
        return V_DOUBLE_FIELD_DESC;
      case V_STRING:
        return V_STRING_FIELD_DESC;
      case V_BOOLEANS:
        return V_BOOLEANS_FIELD_DESC;
      case V_BYTES:
        return V_BYTES_FIELD_DESC;
      case V_SHORTS:
        return V_SHORTS_FIELD_DESC;
      case V_INTEGERS:
        return V_INTEGERS_FIELD_DESC;
      case V_LONGS:
        return V_LONGS_FIELD_DESC;
      case V_DOUBLES:
        return V_DOUBLES_FIELD_DESC;
      case V_STRINGS:
        return V_STRINGS_FIELD_DESC;
      case V_LISTS:
        return V_LISTS_FIELD_DESC;
      default:
        throw new java.lang.IllegalArgumentException("Unknown field id " + setField);
    }
  }

  @Override
  protected org.apache.thrift.protocol.TStruct getStructDesc() {
    return STRUCT_DESC;
  }

  @Override
  protected _Fields enumForId(short id) {
    return _Fields.findByThriftIdOrThrow(id);
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }


  public boolean getVBoolean() {
    if (getSetField() == _Fields.V_BOOLEAN) {
      return (java.lang.Boolean)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vBoolean' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVBoolean(boolean value) {
    setField_ = _Fields.V_BOOLEAN;
    value_ = value;
  }

  public byte getVByte() {
    if (getSetField() == _Fields.V_BYTE) {
      return (java.lang.Byte)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vByte' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVByte(byte value) {
    setField_ = _Fields.V_BYTE;
    value_ = value;
  }

  public short getVShort() {
    if (getSetField() == _Fields.V_SHORT) {
      return (java.lang.Short)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vShort' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVShort(short value) {
    setField_ = _Fields.V_SHORT;
    value_ = value;
  }

  public int getVInteger() {
    if (getSetField() == _Fields.V_INTEGER) {
      return (java.lang.Integer)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vInteger' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVInteger(int value) {
    setField_ = _Fields.V_INTEGER;
    value_ = value;
  }

  public long getVLong() {
    if (getSetField() == _Fields.V_LONG) {
      return (java.lang.Long)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vLong' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVLong(long value) {
    setField_ = _Fields.V_LONG;
    value_ = value;
  }

  public double getVDouble() {
    if (getSetField() == _Fields.V_DOUBLE) {
      return (java.lang.Double)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vDouble' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVDouble(double value) {
    setField_ = _Fields.V_DOUBLE;
    value_ = value;
  }

  public java.lang.String getVString() {
    if (getSetField() == _Fields.V_STRING) {
      return (java.lang.String)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vString' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVString(java.lang.String value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_STRING;
    value_ = value;
  }

  public java.util.List<java.lang.Boolean> getVBooleans() {
    if (getSetField() == _Fields.V_BOOLEANS) {
      return (java.util.List<java.lang.Boolean>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vBooleans' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVBooleans(java.util.List<java.lang.Boolean> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_BOOLEANS;
    value_ = value;
  }

  public byte[] getVBytes() {
    setVBytes(org.apache.thrift.TBaseHelper.rightSize(bufferForVBytes()));
    java.nio.ByteBuffer b = bufferForVBytes();
    return b == null ? null : b.array();
  }

  public java.nio.ByteBuffer bufferForVBytes() {
    if (getSetField() == _Fields.V_BYTES) {
      return org.apache.thrift.TBaseHelper.copyBinary((java.nio.ByteBuffer)getFieldValue());
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vBytes' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVBytes(byte[] value) {
    setVBytes  (java.nio.ByteBuffer.wrap(value.clone()));
  }

  public void setVBytes(java.nio.ByteBuffer value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_BYTES;
    value_ = value;
  }

  public java.util.List<java.lang.Short> getVShorts() {
    if (getSetField() == _Fields.V_SHORTS) {
      return (java.util.List<java.lang.Short>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vShorts' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVShorts(java.util.List<java.lang.Short> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_SHORTS;
    value_ = value;
  }

  public java.util.List<java.lang.Integer> getVIntegers() {
    if (getSetField() == _Fields.V_INTEGERS) {
      return (java.util.List<java.lang.Integer>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vIntegers' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVIntegers(java.util.List<java.lang.Integer> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_INTEGERS;
    value_ = value;
  }

  public java.util.List<java.lang.Long> getVLongs() {
    if (getSetField() == _Fields.V_LONGS) {
      return (java.util.List<java.lang.Long>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vLongs' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVLongs(java.util.List<java.lang.Long> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_LONGS;
    value_ = value;
  }

  public java.util.List<java.lang.Double> getVDoubles() {
    if (getSetField() == _Fields.V_DOUBLES) {
      return (java.util.List<java.lang.Double>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vDoubles' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVDoubles(java.util.List<java.lang.Double> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_DOUBLES;
    value_ = value;
  }

  public java.util.List<java.lang.String> getVStrings() {
    if (getSetField() == _Fields.V_STRINGS) {
      return (java.util.List<java.lang.String>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vStrings' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVStrings(java.util.List<java.lang.String> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_STRINGS;
    value_ = value;
  }

  public java.util.List<SlotValue> getVLists() {
    if (getSetField() == _Fields.V_LISTS) {
      return (java.util.List<SlotValue>)getFieldValue();
    } else {
      throw new java.lang.RuntimeException("Cannot get field 'vLists' because union is currently set to " + getFieldDesc(getSetField()).name);
    }
  }

  public void setVLists(java.util.List<SlotValue> value) {
    if (value == null) throw new java.lang.NullPointerException();
    setField_ = _Fields.V_LISTS;
    value_ = value;
  }

  public boolean isSetVBoolean() {
    return setField_ == _Fields.V_BOOLEAN;
  }


  public boolean isSetVByte() {
    return setField_ == _Fields.V_BYTE;
  }


  public boolean isSetVShort() {
    return setField_ == _Fields.V_SHORT;
  }


  public boolean isSetVInteger() {
    return setField_ == _Fields.V_INTEGER;
  }


  public boolean isSetVLong() {
    return setField_ == _Fields.V_LONG;
  }


  public boolean isSetVDouble() {
    return setField_ == _Fields.V_DOUBLE;
  }


  public boolean isSetVString() {
    return setField_ == _Fields.V_STRING;
  }


  public boolean isSetVBooleans() {
    return setField_ == _Fields.V_BOOLEANS;
  }


  public boolean isSetVBytes() {
    return setField_ == _Fields.V_BYTES;
  }


  public boolean isSetVShorts() {
    return setField_ == _Fields.V_SHORTS;
  }


  public boolean isSetVIntegers() {
    return setField_ == _Fields.V_INTEGERS;
  }


  public boolean isSetVLongs() {
    return setField_ == _Fields.V_LONGS;
  }


  public boolean isSetVDoubles() {
    return setField_ == _Fields.V_DOUBLES;
  }


  public boolean isSetVStrings() {
    return setField_ == _Fields.V_STRINGS;
  }


  public boolean isSetVLists() {
    return setField_ == _Fields.V_LISTS;
  }


  public boolean equals(java.lang.Object other) {
    if (other instanceof SlotValue) {
      return equals((SlotValue)other);
    } else {
      return false;
    }
  }

  public boolean equals(SlotValue other) {
    return other != null && getSetField() == other.getSetField() && getFieldValue().equals(other.getFieldValue());
  }

  @Override
  public int compareTo(SlotValue other) {
    int lastComparison = org.apache.thrift.TBaseHelper.compareTo(getSetField(), other.getSetField());
    if (lastComparison == 0) {
      return org.apache.thrift.TBaseHelper.compareTo(getFieldValue(), other.getFieldValue());
    }
    return lastComparison;
  }


  @Override
  public int hashCode() {
    java.util.List<java.lang.Object> list = new java.util.ArrayList<java.lang.Object>();
    list.add(this.getClass().getName());
    org.apache.thrift.TFieldIdEnum setField = getSetField();
    if (setField != null) {
      list.add(setField.getThriftFieldId());
      java.lang.Object value = getFieldValue();
      if (value instanceof org.apache.thrift.TEnum) {
        list.add(((org.apache.thrift.TEnum)getFieldValue()).getValue());
      } else {
        list.add(value);
      }
    }
    return list.hashCode();
  }
  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }


  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }


}
